% This file is released under the terms of the GNU General Public License,
% version 3. See http://www.gnu.org/licenses/gpl.html

function dfaBendPlot( path, DFA_x,DFA_y, FitInterval )

fig=figure('name','DFA plot');
set(fig,'PaperPositionMode','auto');
set(fig,'Position',[100, 100, 600, 500]);
set(fig,'Visible','off');

DFA_SmallTimeFit_LogSample = min(find(DFA_x>=FitInterval(1)*1000));
DFA_LargeTimeFit_LogSample = max(find(DFA_x<=FitInterval(2)*1000));
X = [ones(1,DFA_LargeTimeFit_LogSample-DFA_SmallTimeFit_LogSample+1)' log10(DFA_x(DFA_SmallTimeFit_LogSample:DFA_LargeTimeFit_LogSample))];
Y = log10(DFA_y(DFA_SmallTimeFit_LogSample:DFA_LargeTimeFit_LogSample));
DFA_exp = X\Y;

loglog(DFA_x, DFA_y, 'ro')
hold on
plot(DFA_x(DFA_SmallTimeFit_LogSample:DFA_LargeTimeFit_LogSample), 10.^(log10(DFA_x(DFA_SmallTimeFit_LogSample:DFA_LargeTimeFit_LogSample)) * DFA_exp(2) + DFA_exp(1)), 'k-','LineWidth',1.5);
hold off
title({'DFA analysis: ', ['\alpha: ' num2str(DFA_exp(2))]})
xlabel('Time (milliseconds)')
ylabel('log_{10}<F(t)>')

print(strcat(path,'DFA_plot.png'),'-dpng');

end