%     Originally created by Arthur-Ervin Avramiea (2018), a.e.avramiea@vu.nl

%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <http://www.gnu.org/licenses/>.

function [kstat,powerlaw_shift] = kstat_optimize(powerData,binSize,minmax)

max_av_size = max(max(powerData),minmax);

disp(max_av_size);

binn = 0:max_av_size;
[ys, xs] = hist(powerData, binn);

[xss, yss] = Logbinning_v2(xs, ys, binSize);
xdat = log10(xss);
ydat = log10(yss/sum(yss));

% ok = ~(isnan(xdat) | isnan(ydat) |isinf(xdat) | isinf(ydat));
 
distance = round(binSize/2);

larger_than_minimum = find(xdat>log10(minmax));

if(length(larger_than_minimum)==0)
    first_larger_than_minimum = length(xdat);
else
    first_larger_than_minimum = larger_than_minimum(1);
end

at_index = length(ydat);
for i=1:(length(ydat)-distance)
    j=length(ydat)-distance-i+1;
    if (~isnan(xdat(j)) & ~isnan(xdat(j+distance)) & ~isnan(ydat(j)) & ~isnan(ydat(j+distance)) & ~isinf(xdat(j)) & ~isinf(xdat(j+distance)) & ~isinf(ydat(j)) & ~isinf(ydat(j+distance)))
        if (( ydat(j+distance)-ydat(j) )/(xdat(j+distance)-xdat(j)))<=-0.5
            at_index = j+distance;
            break
        end
    end
end

if at_index>first_larger_than_minimum
    %nothing to do
else
    for i=at_index:first_larger_than_minimum
        ydat(i)=-10;
    end
end

until_index = first_larger_than_minimum;

xdatsel = xdat(1:until_index);
ydatsel = ydat(1:until_index);
oksel = ~(isnan(xdatsel) | isnan(ydatsel) |isinf(xdatsel) | isinf(ydatsel));

xpsel = 10.^xdatsel(find(oksel));
y2sel=xpsel.^-1.5;
y2logsel = log10(y2sel);

maxdist = max(max(ydatsel(find(oksel))-y2logsel),max(y2logsel-ydatsel(find(oksel))));

fun=@(x)myks(y2logsel+x,ydatsel(find(oksel)));
powerlaw_shift=fminbnd(fun,-maxdist,maxdist);

[H, pValue, kstat] = kstest2(y2logsel+powerlaw_shift,ydatsel(find(oksel)));

end