% This file is released under the terms of the GNU General Public License,
% version 3. See http://www.gnu.org/licenses/gpl.html

function [xdat,ydat] = powerPlot(powerData,fig,binSize,minmax,powerlaw_shift,marker,color)
if fig == 1
    figure;
end

max_av_size = max(max(powerData),minmax);

binn = 0:(max_av_size);
[ys, xs] = hist(powerData, binn);
[xss, yss] = Logbinning_v2(xs, ys, binSize);
hold on;

xdat = log10(xss);
ydat = log10(yss/sum(yss));

for i=1:length(ydat)
    yss_end_index = length(ydat)-i+1;
    if isinf(ydat(yss_end_index))
        ydat(yss_end_index)=-10;
    else
        break;
    end
end

ok = ~(isnan(xdat) | isnan(ydat) |isinf(xdat) | isinf(ydat));

xp = 10.^xdat(find(ok));
y2 = xp.^-1.5;
y2log = log10(y2);
 
plot(xdat(find(ok)),ydat(find(ok)),'linestyle', 'none','Marker', marker,'Color',color);
plot(xdat(find(ok)),y2log+powerlaw_shift,'linestyle', 'none','Marker', marker,'Color','k');

x=[log10(minmax),log10(minmax)];
y=[min(min(ydat(find(ok))),min(y2log+powerlaw_shift)),max(max(ydat(find(ok))),max(y2log+powerlaw_shift))];
line(x,y,'Color','k');

end
