% This file is released under the terms of the GNU General Public License,
% version 3. See http://www.gnu.org/licenses/gpl.html

function [ av_size, av_dura ] = silences( input, timeframe, threshold )
if timeframe == 0
    ind = find(input<threshold);
    av_size = zeros(1,size(ind,2));
    av_dura = zeros(1,size(ind,2));
    count = 0;
    i=1;
    while i <= size(ind,2)
        start = i;
        i=i+1;
        while i <= size(ind,2) && ind(i) == ind(i-1)+1
            i = i+1;
        end
        count = count+1;
        av_size(count) = sum(input(ind(start):ind(i-1)));
        av_dura(count) = i-start;
    end
    av_size = av_size(1:count);
    av_dura = av_dura(1:count);
else
    av_size = zeros(1,10000000);
    av_dura = zeros(1,10000000);
    stopflag = 0;
    avalanche_index = 0;
    i =1;
    while stopflag ~=1
        if ((sum(input(i:(i+timeframe))) < threshold ) && (sum(input((i+timeframe):(i+2*timeframe)))) > threshold)
            %avalanche begins
            m = i+timeframe;
            m_start = m;
            m_end = m+timeframe;
            while (sum(input(m:(m+timeframe))) > threshold)
                m = m+1;
                if (m+timeframe > size(input,2))
                    break;
                end
            end
            m_end = m-1;
            avalanche_index = avalanche_index + 1;
            av_dura(avalanche_index) = 1 + m_end - m_start;
            av_size(avalanche_index) = sum(input(m_start:m_end));
            i = m_end;
        end
        i = i+1;
        if ( (i+2*timeframe)> size(input,2))
            stopflag = 1;
        end
    end
    av_size = av_size(1:avalanche_index);
    av_dura = av_dura(1:avalanche_index);
end

end
