#     Originally created by Arthur-Ervin Avramiea (2018), a.e.avramiea@vu.nl

#     This program is free software: you can redistribute it and/or modify
#     it under the terms of the GNU General Public License as published by
#     the Free Software Foundation, either version 3 of the License, or
#     (at your option) any later version.
# 
#     This program is distributed in the hope that it will be useful,
#     but WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#     GNU General Public License for more details.
# 
#     You should have received a copy of the GNU General Public License
#     along with this program.  If not, see <http://www.gnu.org/licenses/>.

from cros_model.utils import properties
import os,inspect

MAIN_FILE_PATH = "MAIN_FILE_PATH"
LOGS_FILE_PATH = "LOGS_FILE_PATH"
TMP_FILE_PATH = "TMP_FILE_PATH"
LIB_FILE_PATH="LIB_FILE_PATH"
SIMULATION_PARAM_FILES_PATH="SIMULATION_PARAM_FILES_PATH"
SIMULATIONS_PATH = "SIMULATIONS_PATH"
STOPOS_PATH="STOPOS_PATH"
IS_MATLAB_STANDALONE = "IS_MATLAB_STANDALONE"
MATLAB_PATH="MATLAB_PATH"
DATA_FILE_PATH = "DATA_FILE_PATH"
NETWORKS_FILE_PATH = "NETWORKS_FILE_PATH"

def get_path(path):
    return path.replace('\\','/')

def get_configuration():
    config_file_path = os.path.dirname(os.path.abspath(inspect.getfile(inspect.currentframe())))+os.path.sep+"configuration.properties"
    configuration = properties.load_properties_file(config_file_path)
    main_file_path = configuration[MAIN_FILE_PATH]
    for key in configuration.keys():
        if (key != MAIN_FILE_PATH and key!=DATA_FILE_PATH and key!=NETWORKS_FILE_PATH) and "PATH" in key:
            configuration[key]=get_path(main_file_path+configuration[key])

    return configuration
