#     Originally created by Arthur-Ervin Avramiea (2018), a.e.avramiea@vu.nl

#     This program is free software: you can redistribute it and/or modify
#     it under the terms of the GNU General Public License as published by
#     the Free Software Foundation, either version 3 of the License, or
#     (at your option) any later version.
# 
#     This program is distributed in the hope that it will be useful,
#     but WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#     GNU General Public License for more details.
# 
#     You should have received a copy of the GNU General Public License
#     along with this program.  If not, see <http://www.gnu.org/licenses/>.

from subprocess import call,Popen
from cros_model.configuration import configuration as conf
import platform
from cros_model.utils import properties
from cros_model import params as p

def run(real_path):
    configuration = conf.get_configuration()
    
    parameters = properties.load_properties_file(real_path+"Simulation.Parameters")
    
    run_analysis_script_name = parameters[p.RUN_ANALYSIS_SCRIPT_NAME]
    if configuration[conf.IS_MATLAB_STANDALONE]:
        c=call([configuration[conf.MATLAB_PATH]+run_analysis_script_name+" '"+real_path+"'"],stdin=None, stdout=None, stderr=None, shell=True)
    else:
        platform_name = platform.platform()
        if "Windows" in platform_name:
            c=call(["matlab", "-nodesktop", '-wait',"-nosplash","-minimize","-r","addpath('"+configuration[conf.MATLAB_PATH]+"');"+ run_analysis_script_name + ' '+"'"+real_path+"'"+';quit()'])
        else:
            c=call(["matlab", "-nodesktop", "-nosplash","-r","addpath('"+configuration[conf.MATLAB_PATH]+"');"+ run_analysis_script_name + ' '+"'"+real_path+"'"+';quit()'],stdin=None, stdout=None, stderr=None, shell=False)