# -*- coding: utf-8 -*-
"""
Created on Mon Apr 06 17:50:04 2015

@author: Arthur
"""

import multiprocessing as mp
import subprocess
from cros_model.configuration import configuration as conf

simulation_script_run_file = 'main_crit.py'
simulation_configuration_file = 'CRIT_16_23.10.2017_neuromod_paper_net.Parameters'
parameter_set_file = "Neuromod1Net_EE_IE.param"

#parallel process worker - initializes params (needs to be done for each process), runs trial
def worker(params_string,i,q):
    configuration = conf.get_configuration()

    f=open(configuration[conf.LOGS_FILE_PATH]+"log"+str(i)+".txt","w")
    command_array=['python',simulation_script_run_file,simulation_configuration_file]
#     command_array.extend(["batch"])
    command_array.extend(params_string.split())
    subprocess.call(command_array,stdout=f,stderr=f)

#parallel process listener - prints results to file and to screen
def listener(q):
    '''listens for messages on the q, writes to file. '''

    while 1:
        m = q.get()
        if m == 'kill':
            break
        else:
            
            print "done"
    
def main():
    configuration = conf.get_configuration()

    file_path = configuration[conf.STOPOS_PATH]+ parameter_set_file

    manager = mp.Manager()
    q = manager.Queue()

    pool = mp.Pool(mp.cpu_count())

    #AA: listener gets the results from the different files, outputs to screen and prints to file. put listener to work first
    pool.apply_async(listener, (q))

    #AA: fire off workers- which take the trials and distribute them to the processors
    jobs = []
    with open(file_path) as f:
        lines = f.readlines()
        i=0
        for line in lines:
            i=i+1
            print line
#                worker(line,i,q)                
            job = pool.apply_async(worker, (line,i, q))
            jobs.append(job)

    #AA: collect results from the workers through the pool result queue
    for job in jobs:
        job.get()

    #AA: now we are done, kill the listener
    q.put('kill')
    pool.close()

if __name__ == "__main__":
    main()