#     Originally created by Arthur-Ervin Avramiea (2018), a.e.avramiea@vu.nl

#     This program is free software: you can redistribute it and/or modify
#     it under the terms of the GNU General Public License as published by
#     the Free Software Foundation, either version 3 of the License, or
#     (at your option) any later version.
# 
#     This program is distributed in the hope that it will be useful,
#     but WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#     GNU General Public License for more details.
# 
#     You should have received a copy of the GNU General Public License
#     along with this program.  If not, see <http://www.gnu.org/licenses/>.

from os.path import isdir, join, isfile
from os import listdir
import cros_model.params as p
import sys

if len(sys.argv)<2:
    print "Missing path argument. Please provide path for directory where data is located."
    sys.exit()

dirs_path = sys.argv[1]

onlyfolders = [ f for f in listdir(dirs_path) if isdir(join(dirs_path,f)) ]

string = ''
table_header_created=False
table_header=[]

for f in onlyfolders:
    folder_path = join(dirs_path,f)

    params_file = join(folder_path,"Simulation.Parameters")
    criticality_fitness_file = join(folder_path,"CriticalityFitness.txt")

    params_target = p.load_params_file(params_file,[])

    if isfile(criticality_fitness_file):
        criticality_fitness_file = p.load_params_file(criticality_fitness_file,[])
        for key in criticality_fitness_file.keys():
            params_target[key]=criticality_fitness_file[key]

        files_at_path = 'NetworkStatistics.txt'
        network_statistics_params = p.load_params_file(join(folder_path,files_at_path),[])
        for key in network_statistics_params.keys():
            params_target[key]=network_statistics_params[key]

#        files_at_path = 'ActivityStatistics.txt'
#        activity_statistics_params = p.load_params_file(join(folder_path,files_at_path),[])
#        for key in activity_statistics_params.keys():
#            params_target[key] = activity_statistics_params[key]

        if not table_header_created:
            table_header = list(params_target.keys())
            string+=";".join(table_header)+"\n"
            table_header_created=True
	
	try:
            values_array=[]
            for key in table_header:
#		print key
		if key in params_target.keys():
	           values_array.append(str(params_target[key]))
		else:
		   values_array.append("")

            string+=";".join(values_array)+"\n"
	except:
	    print "missing data"

with open(dirs_path+"results.csv","w") as f:
    f.write(string)