#     Originally created by Arthur-Ervin Avramiea (2018), a.e.avramiea@vu.nl

#     This program is free software: you can redistribute it and/or modify
#     it under the terms of the GNU General Public License as published by
#     the Free Software Foundation, either version 3 of the License, or
#     (at your option) any later version.
# 
#     This program is distributed in the hope that it will be useful,
#     but WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#     GNU General Public License for more details.
# 
#     You should have received a copy of the GNU General Public License
#     along with this program.  If not, see <http://www.gnu.org/licenses/>.

def is_number(s):
    try:
        float(s)
        return True
    except ValueError:
        return False

def load_properties_file(file_path):
    new_params = {}

    with open(file_path) as f:
        for line in f:
            line_trimmed = line.strip()

            if len(line_trimmed)==0 or line_trimmed[0]=="#" :
                continue

            line_vec=line_trimmed.split("=")

            if len(line_vec)<2:
                continue

            property_name = line_vec[0].strip()
            property_value = line_vec[1].strip()
            if is_number(property_value):
                property_value = float(property_value)
                try:
                    property_value_int = int(property_value)
                    if property_value_int==property_value:
                        property_value = property_value_int
                except:
                    pass
            elif property_value == "True":
                property_value = True
            elif property_value == "False":
                property_value = False
            new_params[property_name]=property_value

    return new_params