function [all_f,all_p] = get_all_power_spectra_for_ei( dir_path,eeGainVal,eiGainVal )
    try
        
        listing = dir(dir_path);
        k=0;
        all_f = zeros(513,1);
        all_p = zeros(513,10);
        
        for i=1:length(listing)
            disp(length(listing));
            if ~ listing(i).isdir || strcmp(listing(i).name,'.')==1 || strcmp(listing(i).name,'..')==1 
                continue;
            end
            
            my_path=[dir_path filesep listing(i).name filesep];
            
            disp(my_path);
            xlim([0 50]);
            parameters_dict=read_dictionary_and_defaults(strcat(my_path,'Simulation.Parameters'));

            eeGain = parameters_dict('eeGain');
            eiGain = parameters_dict('eiGain');
            
            if str2double(eeGain) ~= eeGainVal | str2double(eiGain) ~= eiGainVal
            %if str2double(eeGain) ~= 1 | str2double(eiGain) ~=1
%             if str2double(eeGain) ~= 1.5 | str2double(eiGain) ~=0.5
                disp([eeGain eiGain]);
                continue;
            else
                disp('found value');
            end
            
            alpha_hp = 8;
            alpha_lp = 12;
            alpha_fo = 0.25;

            sampling_rate = 1000;

            %shuffle random number generator
            rng('shuffle');

            time_series_txt_file_path = strcat(my_path,'Time.Series');

            simulation_data_file_path = strcat(my_path,'SimulationData.h5');

            if exist(time_series_txt_file_path, 'file') == 2
                timeSeries = importdata(time_series_txt_file_path,' ');
            else
                timeSeries = h5read(simulation_data_file_path,'/data/population_spiking_main_network');
                if size(timeSeries,1)<size(timeSeries,2)
                    timeSeries = timeSeries';
                end
                disp(size(timeSeries));
            end


            if isempty(timeSeries)
                disp('empty time series');
                continue;
            end
            k=k+1;

            timeSeriesLength = size(timeSeries,1);

            calc_amplitude = true;
            
            if calc_amplitude

                nfft=2^10; %number of fast fourier transforms, higher this number and the frequency resolution of the spectrum goes up,
                number_of_channels=1;

                Signal = timeSeries;

                %% determine intervals at which power is calculated

                FS=1000;

                [p,f]=pwelch(Signal(:,1),hamming(nfft),0,nfft,FS);
                interval_all=find(f>1&f<60);
                
%                 p=sqrt(p); % transform power to amplitude
                all_f = f;
                all_p(:,k)=p;
             

                %%%%  plot spectrum for each channel, push enter to see all

                %             intervalall=[];
                %             for i=1:5
                %                 intervalall=[intervalall;interval{i}];
                %             end
                %             plot(f(intervalall),p(intervalall))
                %             drawnow
                %             input('')

                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%                 for j=1:nr_interv
%                     integrated(j,i) = mean(p(interval{j}));
%                     normalized(j,i) = mean(p(interval{j}))/sum([mean(p([interval{1}]));mean(p([interval{2}]));mean(p([interval{3}]));mean(p([interval{4}]));mean(p([interval{5}]))]);
%                 end
            end
        end
        
        all_f=all_f(interval_all);
        all_p=all_p(interval_all,:);
    catch E
        disp('errors');
        disp(getReport(E));
    end
end
